﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid

Namespace CellGrid_2008
	Partial Public Class Form1
		Inherits Form
        Public Sub New()
            InitializeComponent()
            Me.gridControl1.ColCount = 10
            Me.gridControl1.RowCount = 50
            Me.gridControl1.EnterKeyBehavior = GridDirectionType.None

            Dim dt As New DataTable()
            dt.Columns.Add("ID")
            dt.Columns.Add("Value")
            For i As Integer = 1 To 5
                Dim dr As DataRow = dt.NewRow()
                dr(0) = i
                dr(1) = "Value" & i
                dt.Rows.Add(dr)
            Next i

            Me.gridControl1.Model(3, 3).CellType = "ComboBox"
            Me.gridControl1.Model(3, 3).DataSource = dt
            Me.gridControl1.Model(3, 3).DisplayMember = "Value"

            Me.gridControl1.Model(5, 3).CellType = "CheckBox"
            Me.gridControl1.Model(5, 3).Description = "Click"
            Me.gridControl1.Model(5, 3).CheckBoxOptions = New GridCheckBoxCellInfo("true", "false", "", False)
            'Event Triggering
            AddHandler gridControl1.KeyDown, AddressOf gridControl1_KeyDown
        End Sub
        Private currentCell As GridCurrentCell
        'Event Customization
        Private Sub gridControl1_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
			If Me.gridControl1.EnterKeyBehavior = GridDirectionType.None Then
				currentCell = Me.gridControl1.CurrentCell
				Dim rowIndex As Integer = currentCell.RowIndex
				Dim colIndex As Integer = currentCell.ColIndex
				Dim info As GridStyleInfo = Me.gridControl1.Model(rowIndex, colIndex)
				'Activate the enter key for checkbox
				If e.KeyCode = Keys.Enter AndAlso info.CellType Is "CheckBox" Then
					e.Handled = True

					If info.CellValue.ToString() = "true" Then
						info.CellValue = "false"
					Else
						info.CellValue = "true"
					End If
				End If
				'Activate the enter key for combobox
				If e.KeyCode = Keys.Enter AndAlso info.CellType Is "ComboBox" Then
					e.Handled = True
					If Not currentCell.IsDroppedDown Then
						currentCell.ShowDropDown()
					Else
						currentCell.CloseDropDown(Syncfusion.Windows.Forms.PopupCloseType.Canceled)
					End If
				End If
			End If
		End Sub

		Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
			If currentCell IsNot Nothing Then
				Dim rowIndex As Integer = currentCell.RowIndex
				Dim colIndex As Integer = currentCell.ColIndex
				Dim info As GridStyleInfo = Me.gridControl1.Model(rowIndex, colIndex)
				'Restricting the F4 and SpaceBar function
				If (keyData = Keys.Space AndAlso info.CellType Is "CheckBox") OrElse (keyData = Keys.F4 AndAlso info.CellType Is "ComboBox") Then
					Return True
				End If
			End If
			Return MyBase.ProcessCmdKey(msg, keyData)
		End Function
	End Class
End Namespace
